package learner;

import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JDesktopPane;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JCheckBox;
import java.awt.SystemColor;

public class LearnerInterface extends JFrame {

	static final long serialVersionUID = 0;

	private Classifier learner;

	private JDesktopPane desk = null;

	private JTextArea console = null;

	private JButton validatebutton = null;

	private JButton exitbutton = null;

	private JComboBox selector = null;

	private JLabel selectorL = null;

	private JLabel validateL = null;

	private JLabel parameterL = null;

	private JLabel datafileL = null;

	private JLabel dataL = null;

	private JLabel labelL = null;

	private JTextField validateT = null;

	private JTextField parameterT = null;

	private JTextField datafileT = null;

	private JTextField dataT = null;

	private JTextField labelT = null;

	private JLabel toclassifyL = null;

	private JTextField toclassifyT = null;

	private JButton classifybutton = null;

	private JScrollPane scrollbars = null;

	private JCheckBox datasetcheckbox = null;

	private JButton performancebutton = null;

	private JButton findbestbutton = null;

	private JButton printdatabutton = null;

	private JCheckBox jCheckBox = null;

	/**
	 * This is the default constructor
	 */
	public LearnerInterface(){
		super();
		initialize();
	}
	
	public static void main(String[] args) {
		try
		{
			new LearnerInterface();
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		try{
			this.setContentPane(getJDesktopPane());
			this.setResizable(false);
			this.setLocation(new java.awt.Point(100,100));
			this.setSize(new java.awt.Dimension(526,446));
		this
				.setTitle("Automated Learning & Adaptive Knowledge Systems - 1D Learning");
		this.setVisible(true);
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(1);
			}
		});
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	/**
	 * This method initializes desk
	 * 
	 * @return javax.swing.JDesktopPane
	 */
	private JDesktopPane getJDesktopPane() {
		if (desk == null) {
			labelL = new JLabel();
			labelL.setBounds(new java.awt.Rectangle(276, 370, 92, 20));
			labelL.setText("Labels column:");
			labelL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			dataL = new JLabel();
			dataL.setBounds(new java.awt.Rectangle(165, 370, 81, 20));
			dataL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			dataL.setText("Data column:");
			datafileL = new JLabel();
			datafileL.setBounds(new java.awt.Rectangle(6, 370, 73, 20));
			datafileL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			datafileL.setText("Dataset file:");
			parameterL = new JLabel();
			parameterL.setBounds(new java.awt.Rectangle(336, 5, 126, 20));
			parameterL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			parameterL.setText("Boosting Iterations :");
			toclassifyL = new JLabel();
			toclassifyL.setBounds(new java.awt.Rectangle(14, 55, 121, 20));
			toclassifyL
					.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			toclassifyL.setText("Element to classify:");
			validateL = new JLabel();
			validateL.setBounds(new java.awt.Rectangle(4, 32, 132, 20));
			validateL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			validateL.setText("Cross Validation Folds:");
			selectorL = new JLabel();
			selectorL.setBounds(new java.awt.Rectangle(3, 5, 177, 20));
			selectorL.setText("Choose your favorite Classifier");
			desk = new JDesktopPane();
			desk.setBackground(java.awt.SystemColor.control);
			desk.add(getJButton(), null);
			desk.add(getJComboBox(), null);
			desk.add(getJButton1(), null);
			desk.add(toclassifyL, null);
			desk.add(getJTextField5(), null);
			desk.add(getJButton2(), null);
			desk.add(selectorL, null);
			desk.add(getJScrollPane(), null);
			desk.add(validateL, null);
			desk.add(getJTextField(), null);
			desk.add(getJTextField1(), null);
			desk.add(parameterL, null);
			desk.add(datafileL, null);
			desk.add(getJTextField2(), null);
			desk.add(dataL, null);
			desk.add(getJTextField3(), null);
			desk.add(labelL, null);
			desk.add(getJTextField4(), null);
			desk.add(getJCheckBox(), null);
			desk.add(getJButton3(), null);
			desk.add(getJButton4(), null);
			desk.add(getPrintdatabutton(), null);
			desk.add(getJCheckBox2(), null);
		}
		return desk;
	}

	/**
	 * This method initializes console
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getJTextArea() {
		if (console == null) {
			console = new JTextArea();
			console.setEditable(false);
			console.setRows(60);
			console.setText("");
			console.setFont(new java.awt.Font("Courier New",
					java.awt.Font.PLAIN, 12));
			console.setColumns(50);
		}
		return console;
	}

	/**
	 * This method initializes classifybutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (classifybutton == null) {
			classifybutton = new JButton();
			classifybutton.setBounds(new java.awt.Rectangle(180, 56, 130, 20));
			classifybutton.setText("Classify Element");
			classifybutton
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							double value;
							if (toclassifyT.getText().replaceAll(",", ".")
									.matches("\\d+\\.?[\\d+]?"))
								value = new Double(toclassifyT.getText()
										.replace(",", ".")).doubleValue();
							else {
								JOptionPane
										.showMessageDialog(null,
												"Invalid value specified, please insert a number");
								return;
							}
							reinitClassifier();
							console
									.setText(console.getText()
											+ "========================= Classification ============================\n"
											+ "Algorithm = "
											+ selector.getSelectedItem()
											+ " ("
											+ parameterT.getText()
											+ ")\n"
											+ "Value "
											+ toclassifyT.getText()
											+ " is classified as class "
											+ learner.classify(value)
											+ "\n"
											+ "=====================================================================\n\n");
						}
					});
		}
		return classifybutton;
	}

	/**
	 * This method initializes validatebutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (validatebutton == null) {
			validatebutton = new JButton();
			validatebutton.setBounds(new java.awt.Rectangle(180, 30, 130, 20));
			validatebutton.setText("Cross Validate");
			validatebutton
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							reinitClassifier();
							double[] performance = learner
									.crossvalidate(Integer.parseInt(validateT
											.getText()));
							console
									.setText(console.getText()
											+ "========================= Cross Validation ==========================\n"
											+ "Algorithm = "
											+ selector.getSelectedItem()
											+ " ("
											+ parameterT.getText()
											+ ")\n"
											+ "Folds = "
											+ Integer.parseInt(validateT
													.getText())
											+ "\n"
											+ "Average Performance = "
											+ Data.mean(performance)
											+ "\nStandard Deviation = "
											+ Data.std(performance)
											+ "\n"
											+ "=====================================================================\n\n");
						}
					});

		}
		return validatebutton;
	}

	/**
	 * This method initializes selector
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox() {
		if (selector == null) {
			selector = new JComboBox();
			selector.setBounds(new java.awt.Rectangle(180, 5, 129, 20));
			selector.addItem("Adaboost");
			selector.addItem("Knn");
			selector.addItem("DistanceMajority");
			selector.addItem("Parzen");
			selector.addItem("Linear");
			selector.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					switch (selector.getSelectedIndex()) {
					case 0:
						parameterL.setText("Boosting Iterations:");
						findbestbutton.setVisible(false);
						parameterL.setVisible(true);
						parameterT.setVisible(true);
						break;
					case 1:
						parameterL.setText("Required Neighbors:");
						findbestbutton.setVisible(true);
						parameterL.setVisible(true);
						parameterT.setVisible(true);
						findbestbutton.setText("Find Best Neighbors K");
						break;
					case 2:
						parameterL.setText("Distance:");
						findbestbutton.setVisible(true);
						parameterL.setVisible(true);
						parameterT.setVisible(true);
						findbestbutton.setText("Find Best Distance");
						break;
					case 3:
						parameterL.setText("Smoothing:");
						findbestbutton.setVisible(true);
						parameterL.setVisible(true);
						parameterT.setVisible(true);
						findbestbutton.setText("Estimate Smoothing");
						break;
					case 4:
						findbestbutton.setVisible(false);
						parameterL.setVisible(false);
						parameterT.setVisible(false);
						break;
					}
				}
			});

		}
		return selector;
	}

	/**
	 * This method initializes exitbutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (exitbutton == null) {
			exitbutton = new JButton();
			exitbutton.setBounds(new java.awt.Rectangle(402, 370, 109, 41));
			exitbutton.setText("Exit");
			exitbutton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					doExit();
				}
			});
		}
		return exitbutton;
	}

	/**
	 * This method initializes validateT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (validateT == null) {
			validateT = new JTextField();
			validateT.setBounds(new java.awt.Rectangle(135, 31, 45, 20));
			validateT.setText("15");
		}
		return validateT;
	}

	/**
	 * This method initializes parameterT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1() {
		if (parameterT == null) {
			parameterT = new JTextField();
			parameterT.setBounds(new java.awt.Rectangle(462, 5, 54, 20));
			parameterT.setText("10");
		}
		return parameterT;
	}

	/**
	 * This method initializes datafileT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField2() {
		if (datafileT == null) {
			datafileT = new JTextField();
			datafileT.setBounds(new java.awt.Rectangle(79, 370, 77, 20));
			datafileT.setEnabled(false);
			datafileT.setText("crx.data");
		}
		return datafileT;
	}

	/**
	 * This method initializes dataT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField3() {
		if (dataT == null) {
			dataT = new JTextField();
			dataT.setBounds(new java.awt.Rectangle(245, 370, 26, 20));
			dataT.setText("10");
		}
		return dataT;
	}

	/**
	 * This method initializes labelT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField4() {
		if (labelT == null) {
			labelT = new JTextField();
			labelT.setBounds(new java.awt.Rectangle(368, 370, 26, 20));
			labelT.setEnabled(false);
			labelT.setText("15");
		}
		return labelT;
	}

	private void reinitClassifier() {
		try {
			if (datasetcheckbox.isSelected()
					&& !(dataT.getText().equals("1")
							|| dataT.getText().equals("2")
							|| dataT.getText().equals("7")
							|| dataT.getText().equals("10")
							|| dataT.getText().equals("13") || dataT.getText()
							.equals("14"))) {
				JOptionPane
						.showMessageDialog(
								this,
								"The specified data column in not allowed on the default dataset. \nAllowed values: 1,2,7,10,13,14\nLast correct setting will be used",
								"Error", JOptionPane.ERROR_MESSAGE);

				return;
			}

			Data data = new Data(datafileT.getText(), Integer.parseInt(dataT
					.getText()), Integer.parseInt(labelT.getText()));
			if (jCheckBox.isSelected())
				data.shuffle();
			switch (selector.getSelectedIndex()) {
			case 0:
				learner = new Adaboost(data, Integer.parseInt(parameterT
						.getText()));
				break;
			case 1:
				if (data.fulldata.length < Integer.parseInt(parameterT
						.getText()))
					JOptionPane
							.showMessageDialog(
									this,
									"The indicated neighbors are bigger than the dataset itself. Please select a lower value for this field");
				else
					learner = new Knn(data, new Integer(parameterT.getText())
							.intValue());
				break;
			case 2:
				if (data.fulldata.length < Integer.parseInt(parameterT
						.getText()))
					JOptionPane
							.showMessageDialog(
									this,
									"The indicated distance is  bigger than the dataset itself. Please select a lower value for this field");
				else
					learner = new DistanceMajority(data, Integer
							.parseInt(parameterT.getText()));
				break;
			case 3:
				learner = new Parzen(data, Double.parseDouble(parameterT
						.getText()));
				break;
			case 4:
				learner = new Linear(data, false);
				break;
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
			return;
		}
	}

	private void doExit() {
		int state = JOptionPane.showConfirmDialog(this,
				"Are you sure you want to quit?", "Quit",
				JOptionPane.YES_OPTION & JOptionPane.NO_OPTION);
		if (state == JOptionPane.YES_OPTION)
			System.exit(0);
	}

	/**
	 * This method initializes toclassifyT
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField5() {
		if (toclassifyT == null) {
			toclassifyT = new JTextField();
			toclassifyT.setBounds(new java.awt.Rectangle(135, 56, 45, 20));
		}
		return toclassifyT;
	}

	/**
	 * This method initializes scrollbars
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (scrollbars == null) {
			scrollbars = new JScrollPane(getJTextArea());
			scrollbars.setBounds(new java.awt.Rectangle(6, 88, 509, 277));

			scrollbars.setViewportView(getJTextArea());
		}
		return scrollbars;
	}

	/**
	 * This method initializes datasetcheckbox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (datasetcheckbox == null) {
			datasetcheckbox = new JCheckBox();
			datasetcheckbox.setBounds(new java.awt.Rectangle(2, 392, 156, 20));
			datasetcheckbox.setSelected(true);
			datasetcheckbox.setBackground(java.awt.SystemColor.control);
			datasetcheckbox.setText("Use Default dataset file");
			datasetcheckbox
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (!datasetcheckbox.isSelected()) {
								JOptionPane
										.showMessageDialog(
												null,
												"Warning: Using this option incorrectly may introduce strange application behaviours");
								datafileT.setEnabled(true);
								labelT.setEnabled(true);
							} else {
								datafileT.setText("crx.data");
								labelT.setText("15");
								datafileT.setEnabled(false);
								labelT.setEnabled(false);
							}

						}
					});
		}
		return datasetcheckbox;
	}

	/**
	 * This method initializes performancebutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton3() {
		if (performancebutton == null) {
			performancebutton = new JButton();
			performancebutton
					.setBounds(new java.awt.Rectangle(340, 56, 175, 20));
			performancebutton.setText("Training Error");
			performancebutton
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							reinitClassifier();
							double performance = learner
									.test(learner.getdata().training);
							console
									.setText(console.getText()
											+ "========================= Training Error ============================\n"
											+ "Algorithm = "
											+ selector.getSelectedItem()
											+ " ("
											+ parameterT.getText()
											+ ")\n"
											+ "Performance: "
											+ performance
											+ "\nTraining Error: "
											+ (100 - performance)
											+ "\n"
											+ "=====================================================================\n\n");
						}

					});
		}
		return performancebutton;
	}

	/**
	 * This method initializes findbestbutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton4() {
		if (findbestbutton == null) {
			findbestbutton = new JButton();
			findbestbutton.setBounds(new java.awt.Rectangle(340, 30, 175, 20));
			findbestbutton.setVisible(false);
			findbestbutton
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							int state = JOptionPane
									.showConfirmDialog(
											null,
											"This operation is computationally expansive and may require few minutes. Continue?",
											"Warning", JOptionPane.YES_OPTION
													& JOptionPane.NO_OPTION);
							if (state != JOptionPane.YES_OPTION)
								return;
							reinitClassifier();
							console
									.setText(console.getText()
											+ "============================ Find Best Parameter ====================\n"
											+ " Best Parameter found : "
											+ learner.findparameter()
											+ "\n"
											+ "=====================================================================\n\n");
						}

					});
		}
		return findbestbutton;
	}

	/**
	 * This method initializes printdatabutton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getPrintdatabutton() {
		if (printdatabutton == null) {
			printdatabutton = new JButton();
			printdatabutton
					.setBounds(new java.awt.Rectangle(277, 392, 116, 20));
			printdatabutton.setText("Print Dataset");
			printdatabutton
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							reinitClassifier();
							console
									.setText(console.getText()
											+ "=============================== Dataset =============================\n"
											+ "Data\tLabel\tWeight\n"
											+ learner.getdata().print(
													learner.getdata().fulldata,
													-1)
											+ "\n"
											+ "=====================================================================\n\n");
						}
					});
		}
		return printdatabutton;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox2() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setBounds(new java.awt.Rectangle(165, 392, 105, 20));
			jCheckBox.setSelected(false);
			jCheckBox.setText("Shuffle data");
			jCheckBox.setBackground(SystemColor.control);
		}
		return jCheckBox;
	}

} // @jve:decl-index=0:visual-constraint="173,145"
